;Starting in the top left corner of a 22 grid, there are 6 routes
;(without backtracking) to the bottom right corner.

;How many routes are there through a 2020 grid?

;; incorrect approach
;; (defun count-paths (num)
;;   (- (* num 4) 2))
;;
;; (loop for ii from 1 to 20
;;       do
;;       (format t "~a:~a~&"
;; 	      ii
;; 	      (count-paths ii)))


;; what about the # of edges / 2?
;; 1x1 has   4 edges => 2 paths
;; 2x2 has  12 edges => 6 paths
;; 3x3 has  

(defun count-paths (num)
  (/ (+
      (* num 4)
      (* 2 num (- num 1)))
     2))

(count-paths 1)
(count-paths 2)
(count-paths 20) ; => 420
